%define ocamlname cohttp

Name:           ocaml-%{ocamlname}
Version:        1.1.0
Release:        1%{?dist}.emp1
Summary:        An OCaml library for HTTP clients and servers
License:        ISC
URL:            https://github.com/mirage/ocaml-%{ocaml-name}
Source0:        %{ocamlname}-%{version}.tbz

Requires:  	ocaml >= 4.03.0
Requires:	ocaml-re >= 1.7.2
Requires:	ocaml-uri >= 1.9.0
Requires:	ocaml-fieldslib
Requires:	ocaml-sexplib
Requires:	ocaml-stringext
Requires:	ocaml-base64 >= 2.0.0

BuildRequires:  opam-installer >= 2.0
BuildRequires:  ocaml >= 4.03.0
BuildRequires:  jbuilder
BuildRequires:	ocaml-ppx_type_conv >= 0.9.1
BuildRequires:	ocaml-ppx_fields_conv-devel >= 0.9.0
BuildRequires:	ocaml-ppx_sexp_conv >= 0.9.0
BuildRequires:	ocaml-fmt
BuildRequires:	ocaml-jsonm-devel
BuildRequires:	ocaml-alcotest
BuildRequires:	ocaml-re-devel >= 1.7.2
BuildRequires:	ocaml-uri-devel >= 1.9.0
BuildRequires:	ocaml-fieldslib-devel
BuildRequires:	ocaml-sexplib-devel
BuildRequires:	ocaml-stringext-devel
BuildRequires:	ocaml-base64-devel >= 2.0.0

%description
Cohttp is an OCaml library for creating HTTP daemons. It has a portable
HTTP parser, and implementations using various asynchronous programming
libraries:

* `Cohttp_lwt_unix` uses the [Lwt](https://ocsigen.org/lwt/) library, and
  specifically the UNIX bindings.
* `Cohttp_async` uses the [Async](https://realworldocaml.org/v1/en/html/concurrent-programming-with-async.html)
  library.
* `Cohttp_lwt` exposes an OS-independent Lwt interface, which is used
  by the [Mirage](https://mirage.io/) interface to generate standalone
  microkernels (use the cohttp-mirage subpackage).
* `Cohttp_lwt_xhr` compiles to a JavaScript module that maps the Cohttp
  calls to XMLHTTPRequests.  This is used to compile OCaml libraries like
  the GitHub bindings to JavaScript and still run efficiently.

You can implement other targets using the parser very easily. Look at the `IO`
signature in `lib/s.mli` and implement that in the desired backend.

You can activate some runtime debugging by setting `COHTTP_DEBUG` to any
value, and all requests and responses will be written to stderr.  Further
debugging of the connection layer can be obtained by setting `CONDUIT_DEBUG`
to any value.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:	ocaml-re-devel >= 1.7.2
Requires:	ocaml-uri-devel >= 1.9.0
Requires:	ocaml-fieldslib-devel
Requires:	ocaml-sexplib-devel
Requires:	ocaml-stringext-devel
Requires:	ocaml-base64-devel >= 2.0.0

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n %{ocamlname}-%{version}

%build
jbuilder subst
jbuilder build  -p %{ocamlname} %{?_smp_mflags}

%install
opam-installer \
	--prefix=%{buildroot}/%{_libdir}/ocaml \
	--libdir=%{buildroot}/%{_libdir}/ocaml \
	%{ocamlname}.install

# on ARM tests fail
%ifnarch %{arm}
%check
jbuilder runtest  -p %{ocamlname} %{?_smp_mflags}
%endif

%files
%doc %{_libdir}/ocaml/doc/%{ocamlname}/LICENSE.md
%{_libdir}/ocaml/%{ocamlname}
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/%{ocamlname}/*.a
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmxa
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%exclude %{_libdir}/ocaml/%{ocamlname}/*.mli

%files devel
%doc %{_libdir}/ocaml/doc/%{ocamlname}/CHANGES.md
%doc %{_libdir}/ocaml/doc/%{ocamlname}/README.md
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{ocamlname}/*.a
%{_libdir}/ocaml/%{ocamlname}/*.cmxa
%{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%{_libdir}/ocaml/%{ocamlname}/*.mli
